<?php
namespace Porth\Borderstyle\Domain\Model;


    /***************************************************************
     *
     *  Copyright notice
     *
     *  (c) 2016 Dr. Dieter Porth <info@mobger.de>
     *
     *  All rights reserved
     *
     *  This script is free software; you can redistribute it and/or modify
     *  it under the terms of the GNU General Public License as published by
     *  the Free Software Foundation; either version 3 of the License, or
     *  (at your option) any later version.
     *
     *  The GNU General Public License can be found at
     *  http://www.gnu.org/copyleft/gpl.html.
     *
     *  This copyright notice MUST APPEAR in all copies of the script!
     ***************************************************************/

/**
 * Picturing
 */
class Picturing extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * nickname
     * 
     * @var string
     */
    protected $nickname = '';
    
    /**
     * source
     * 
     * @var \TYPO3\CMS\Extbase\Domain\Model\FileReference
     */
    protected $source = null;

    /**
     * sourcewidth
     *
     * @var int
     */
    protected $sourcewidth = 0;

    /**
     * sourceheight
     *
     * @var int
     */
    protected $sourceheight = 0;

    /**
     * outset
     * 
     * @var string
     */
    protected $outset = '';
    
    /**
     * typeRepeat
     * 
     * @var string
     */
    protected $typeRepeat = '';
    
    /**
     * slice
     * 
     * @var string
     */
    protected $slice = '';
    
    /**
     * Width (no use in Browser - 2016)
     * 
     * @var string
     */
    protected $width = '';

    /**
     * fill
     *
     * @var bool
     */
    protected $fill = false;

    /**
     * Returns the nickname
     * 
     * @return string $nickname
     */
    public function getNickname()
    {
        return $this->nickname;
    }
    
    /**
     * Sets the nickname
     * 
     * @param string $nickname
     * @return void
     */
    public function setNickname($nickname)
    {
        $this->nickname = $nickname;
    }
    
    /**
     * Returns the source
     * 
     * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference $source
     */
    public function getSource()
    {
        return $this->source;
    }
    
    /**
     * Sets the source
     * 
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $source
     * @return void
     */
    public function setSource(\TYPO3\CMS\Extbase\Domain\Model\FileReference $source)
    {
        $this->source = $source;
    }

    /**
     * Returns the sourcewidth
     *
     * @return int sourcewidth
     */
    public function getSourcewidth()
    {
        return $this->sourcewidth;
    }

    /**
     * Sets the sourcewidth
     *
     * @param int $sourcewidth
     * @return void
     */
    public function setSourcewidth($sourcewidth)
    {
        $this->sourcewidth = $sourcewidth;
    }

    /**
     * Returns the sourceheight
     *
     * @return int sourceheight
     */
    public function getSourceheight()
    {
        return $this->sourceheight;
    }

    /**
     * Sets the sourceheight
     *
     * @param int $sourceheight
     * @return void
     */
    public function setSourceheight($sourceheight)
    {
        $this->sourceheight = $sourceheight;
    }

    /**
     * Returns the outset
     * 
     * @return string $outset
     */
    public function getOutset()
    {
        return $this->outset;
    }
    
    /**
     * Sets the outset
     * 
     * @param string $outset
     * @return void
     */
    public function setOutset($outset)
    {
        $this->outset = $outset;
    }
    
    /**
     * Returns the typeRepeat
     * 
     * @return string $typeRepeat
     */
    public function getTypeRepeat()
    {
        return $this->typeRepeat;
    }
    
    /**
     * Sets the typeRepeat
     * 
     * @param string $typeRepeat
     * @return void
     */
    public function setTypeRepeat($typeRepeat)
    {
        $this->typeRepeat = $typeRepeat;
    }
    
    /**
     * Returns the slice
     * 
     * @return string $slice
     */
    public function getSlice()
    {
        return $this->slice;
    }
    
    /**
     * Sets the slice
     * 
     * @param string $slice
     * @return void
     */
    public function setSlice($slice)
    {
        $this->slice = $slice;
    }
    
    /**
     * Returns the width
     * 
     * @return string $width
     */
    public function getWidth()
    {
        return $this->width;
    }
    
    /**
     * Sets the width
     * 
     * @param string $width
     * @return void
     */
    public function setWidth($width)
    {
        $this->width = $width;
    }


    /**
     * Returns the fill
     *
     * @return bool $fill
     */
    public function getFill()
    {
        return $this->fill;
    }

    /**
     * Sets the fill
     *
     * @param bool $fill
     * @return void
     */
    public function setFill($fill)
    {
        $this->fill = $fill;
    }

    /**
     * Returns the boolean state of fill
     *
     * @return bool
     */
    public function isFill()
    {
        return $this->fill;
    }


}