<?php
namespace Porth\Borderstyle\Domain\Model;


    /***************************************************************
     *
     *  Copyright notice
     *
     *  (c) 2016 Dr. Dieter Porth <info@mobger.de>
     *
     *  All rights reserved
     *
     *  This script is free software; you can redistribute it and/or modify
     *  it under the terms of the GNU General Public License as published by
     *  the Free Software Foundation; either version 3 of the License, or
     *  (at your option) any later version.
     *
     *  The GNU General Public License can be found at
     *  http://www.gnu.org/copyleft/gpl.html.
     *
     *  This copyright notice MUST APPEAR in all copies of the script!
     ***************************************************************/

/**
 * Theme
 */
class Theme extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * nickname
     * 
     * @var string
     */
    protected $nickname = '';
    
    /**
     * className
     * 
     * @var string
     */
    protected $className = '';
    
    /**
     * prefixClassName
     * 
     * @var string
     */
    protected $prefixClassName = '';
    
    /**
     * radius
     * 
     * @var string
     */
    protected $radius = '';

    /**
     * width
     *
     * @var string
     */
    protected $width = '';

    /**
     * typus
     *
     * @var string
     */
    protected $typus = 0;
    
    /**
     * borderTop
     * 
     * @var \Porth\Borderstyle\Domain\Model\Styling
     * @lazy
     */
    protected $borderTop = null;
    
    /**
     * borderRight
     * 
     * @var \Porth\Borderstyle\Domain\Model\Styling
     * @lazy
     */
    protected $borderRight = null;
    
    /**
     * borderBottom
     * 
     * @var \Porth\Borderstyle\Domain\Model\Styling
     * @lazy
     */
    protected $borderBottom = null;
    
    /**
     * borderLeft
     * 
     * @var \Porth\Borderstyle\Domain\Model\Styling
     * @lazy
     */
    protected $borderLeft = null;
    
    /**
     * picturing
     * 
     * @var \Porth\Borderstyle\Domain\Model\Picturing
     * @lazy
     */
    protected $picturing = null;

    /**
     * Returns the nickname
     * 
     * @return string $nickname
     */
    public function getNickname()
    {
        return $this->nickname;
    }
    
    /**
     * Sets the nickname
     * 
     * @param string $nickname
     * @return void
     */
    public function setNickname($nickname)
    {
        $this->nickname = $nickname;
    }
    
    /**
     * Returns the className
     * 
     * @return string $className
     */
    public function getClassName()
    {
        return $this->className;
    }
    
    /**
     * Sets the className
     * 
     * @param string $className
     * @return void
     */
    public function setClassName($className)
    {
        $this->className = $className;
    }
    
    /**
     * Returns the prefixClassName
     * 
     * @return string $prefixClassName
     */
    public function getPrefixClassName()
    {
        return $this->prefixClassName;
    }
    
    /**
     * Sets the prefixClassName
     * 
     * @param string $prefixClassName
     * @return void
     */
    public function setPrefixClassName($prefixClassName)
    {
        $this->prefixClassName = $prefixClassName;
    }
    
    /**
     * Returns the radius
     * 
     * @return string $radius
     */
    public function getRadius()
    {
        return $this->radius;
    }
    
    /**
     * Sets the radius
     * 
     * @param string $radius
     * @return void
     */
    public function setRadius($radius)
    {
        $this->radius = $radius;
    }

    /**
     * Returns the width
     *
     * @return string $width
     */
    public function getWidth()
    {
        return $this->width;
    }

    /**
     * Sets the width
     *
     * @param string $width
     * @return void
     */
    public function setWidth($width)
    {
        $this->width = $width;
    }

    /**
     * Returns the typus
     *
     * @return string $typus
     */
    public function getTypus()
    {
        return $this->typus;
    }

    /**
     * Sets the typus
     *
     * @param string $typus
     * @return void
     */
    public function setTypus($typus)
    {
        $this->typus = $typus;
    }

    /**
     * Returns the borderTop
     * 
     * @return \Porth\Borderstyle\Domain\Model\Styling $borderTop
     */
    public function getBorderTop()
    {
        return $this->borderTop;
    }
    
    /**
     * Sets the borderTop
     * 
     * @param \Porth\Borderstyle\Domain\Model\Styling $borderTop
     * @return void
     */
    public function setBorderTop(\Porth\Borderstyle\Domain\Model\Styling $borderTop)
    {
        $this->borderTop = $borderTop;
    }
    
    /**
     * Returns the borderRight
     * 
     * @return \Porth\Borderstyle\Domain\Model\Styling $borderRight
     */
    public function getBorderRight()
    {
        return $this->borderRight;
    }
    
    /**
     * Sets the borderRight
     * 
     * @param \Porth\Borderstyle\Domain\Model\Styling $borderRight
     * @return void
     */
    public function setBorderRight(\Porth\Borderstyle\Domain\Model\Styling $borderRight)
    {
        $this->borderRight = $borderRight;
    }
    
    /**
     * Returns the borderBottom
     * 
     * @return \Porth\Borderstyle\Domain\Model\Styling $borderBottom
     */
    public function getBorderBottom()
    {
        return $this->borderBottom;
    }
    
    /**
     * Sets the borderBottom
     * 
     * @param \Porth\Borderstyle\Domain\Model\Styling $borderBottom
     * @return void
     */
    public function setBorderBottom(\Porth\Borderstyle\Domain\Model\Styling $borderBottom)
    {
        $this->borderBottom = $borderBottom;
    }
    
    /**
     * Returns the borderLeft
     * 
     * @return \Porth\Borderstyle\Domain\Model\Styling $borderLeft
     */
    public function getBorderLeft()
    {
        return $this->borderLeft;
    }
    
    /**
     * Sets the borderLeft
     * 
     * @param \Porth\Borderstyle\Domain\Model\Styling $borderLeft
     * @return void
     */
    public function setBorderLeft(\Porth\Borderstyle\Domain\Model\Styling $borderLeft)
    {
        $this->borderLeft = $borderLeft;
    }
    
    /**
     * Returns the picturing
     * 
     * @return \Porth\Borderstyle\Domain\Model\Picturing $picturing
     */
    public function getPicturing()
    {
        return $this->picturing;
    }
    
    /**
     * Sets the picturing
     * 
     * @param \Porth\Borderstyle\Domain\Model\Picturing $picturing
     * @return void
     */
    public function setPicturing(\Porth\Borderstyle\Domain\Model\Picturing $picturing)
    {
        $this->picturing = $picturing;
    }
}