<?php
namespace Porth\Borderstyle\Domain\Repository;


    /***************************************************************
     *
     *  Copyright notice
     *
     *  (c) 2016 Dr. Dieter Porth <info@mobger.de>
     *
     *  All rights reserved
     *
     *  This script is free software; you can redistribute it and/or modify
     *  it under the terms of the GNU General Public License as published by
     *  the Free Software Foundation; either version 3 of the License, or
     *  (at your option) any later version.
     *
     *  The GNU General Public License can be found at
     *  http://www.gnu.org/copyleft/gpl.html.
     *
     *  This copyright notice MUST APPEAR in all copies of the script!
     ***************************************************************/

/**
 * The repository for Themes
 */
class ThemeRepository extends \TYPO3\CMS\Extbase\Persistence\Repository
{

    /**
     * @var array
     */
    protected $defaultOrderings = array(
        'sorting' => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING
    );


    // METHOD 1: Presets for Repository
    public function initializeObject() {
        // get the settings
        $querySettings = $this->objectManager->get('TYPO3\\CMS\\Extbase\\Persistence\\Generic\\Typo3QuerySettings');

        // modify the settings
        $querySettings->setRespectStoragePage(FALSE);

        // store the settings as default-values
        $this->setDefaultQuerySettings($querySettings);
    }

    /**
     * @param string|array $storagePid
     * @return array|\TYPO3\CMS\Extbase\Persistence\QueryAttributeInterface
     */
    public function findAllOptions($storagePid = [])
    {
        $query = $this->createQuery();
        if (is_string($storagePid)) {
            if (strpos($storagePid,',') === false) {
                if ((int)$storagePid >0) {
                    $storagePid = [$storagePid];
                } else {
                    $storagePid = [];
                }
            } else {
                $storagePid = explode(',', $storagePid );
            }
        }
        if (count($storagePid)<= 0) {
            $query->getQuerySettings()
                ->setRespectStoragePage(FALSE);
        } else {
            $query->getQuerySettings()
                ->setRespectStoragePage(TRUE)
                ->setStoragePageIds($storagePid);
        }
        $query->matching(
            $query->logicalAnd(
                $query->equals('deleted', false),
                $query->equals('hidden', false)
            )
        );

        return $query->execute();
    }
}