<?php
namespace Porth\Borderstyle\Evaluation;


    /***************************************************************
     *
     *  Copyright notice
     *
     *  (c) 2016 Dr. Dieter Porth <info@mobger.de>
     *
     *  All rights reserved
     *
     *  This script is free software; you can redistribute it and/or modify
     *  it under the terms of the GNU General Public License as published by
     *  the Free Software Foundation; either version 3 of the License, or
     *  (at your option) any later version.
     *
     *  The GNU General Public License can be found at
     *  http://www.gnu.org/copyleft/gpl.html.
     *
     *  This copyright notice MUST APPEAR in all copies of the script!
     ***************************************************************/


/**
 * Class for field value validation/evaluation to be used in 'eval' of TCA
 *
 * A Dead end?
 * Problem: I see no good concept to send informations about the fail of evaluatioons
 * Problem: How to use jQuery and I see no way, to make the is_in-Information avaiable for the javascript-functions
 *
 * @todo define a javascript-function to evaluate the entrys on client-side,
 * @todo Unit-Test for code-coverage
 * @todo Try the usage of cookie for the informations-transfer
 */
class TupelEvaluation
{
    const VALUES_ODER_MEASURES_NOT_ALLOWED = ' (values oder measures not allowed))';
    const ONLY_MAXCOUNT_PIECES = ' pieces are the maximum. ';

    /**
     * JavaScript code for client side validation/evaluation
     *
     * @return string JavaScript code for client side validation/evaluation
     */
    public function returnFieldJS()
    {
        return '
    return value ;
';

    }

    /**
     * @param $words
     * @param $params
     * @param $measures
     * @param $percentage
     * @param $rawpart
     * @return bool
     */
    protected function evaluatePart($words, $params, $measures, $percentage, $rawpart)
    {
        $part = $rawpart;
        $textPart = preg_replace('/[0-9]/', '', $part);

        $set = false;
        $set = $set ||
            (
                (count($words) > 0) &&
                (false !== array_search($part, $words, true))
            );
        $set = $set ||
            (
                (count($params) > 0) &&
                (false !== array_search($part, $params, true))
            );
        $set = $set ||
            (
                ((abs((int)$part)) >= 0) &&
                (count($measures) > 0) &&
                (
                    (false !== array_search($textPart, $measures, true)) ||
                    ($textPart === '')
                )
            );
        $set = $set ||
            (
                (((int)$part) >= 0) &&
                (((int)$part) <= 100) &&
                ($textPart === $percentage)
            );
        return $set;
    }

    /**
     * @param $is_in
     * @return array
     */
    protected function resolveIsIn($is_in)
    {
        $check = explode(';', $is_in);
        // $maxTupel
        $check[0] = (
        isset($check[0]) ?
            abs((int)$check[0]) :
            1
        );
        //    $percentage = (
        $check[1] = (
        isset($check[1]) ?
            trim($check[1]) :
            ''
        );
        //    $measures = (
        $check[2] = (
        isset($check[2]) ?
            explode(',', $check[2]) :
            ''
        );
        //    $words = (
        $check[3] = (
        isset($check[3]) ?
            explode(',', $check[3]) :
            ''
        );
        //    $params = (
        $check[4] = (
        isset($check[4]) ?
            explode(',', $check[4]) :
            ''
        );
        return $check;

    }

    /**
     * Server-side validation/evaluation on saving the record - dont - save the old value instead of a wrong Value
     *
     * @param string $value The field value to be evaluated
     * @param string $is_in The "is_in" value of the field configuration from TCA
     * @param bool $set Boolean defining if the value is written to the database or not. Must be passed by reference and changed if needed.
     * @return string Evaluated field value
     */
    public function evaluateFieldValue($value, $is_in, &$set)
    {
        list($maxTupel, $percentage, $measures, $words, $params) = self::resolveIsIn($is_in);
        $normValue = '';
        $testValue = trim($value);
        while ($normValue !== $testValue) {
            $normValue = $testValue;
            $testValue = str_replace('  ', ' ', $value);
        }
        $parts = explode(' ', $testValue);
        $set = true;
        if (count($parts) <= 0) {
            $set = true;
            $resultValue = '';
        } else if (count($parts) > $maxTupel) {
            $set = false;
            $resultValue = $maxTupel . self::ONLY_MAXCOUNT_PIECES . implode(' ', $parts);
        } else if (count($parts) === 1) {
            $set = self::evaluatePart($words, $params, $measures, $percentage, $parts[0]);
            $resultValue = ($set ? '' : self::VALUES_ODER_MEASURES_NOT_ALLOWED) . $parts[0];
        } else {
            $set = true;
            $resultValue = '';
            foreach ($parts as $part) {
                $partSet = self::evaluatePart($words, $params, $measures, $percentage, $part);
                $resultValue .= ($partSet ? ' ' : self::VALUES_ODER_MEASURES_NOT_ALLOWED) . $part;
                $set = $set && $partSet;
            }
        }
        $message = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Messaging\\FlashMessage',
            'My message text',
            'Message Header', // the header is optional
            \TYPO3\CMS\Core\Messaging\FlashMessage::WARNING, // the severity is optional as well and defaults to \TYPO3\CMS\Core\Messaging\FlashMessage::OK
            TRUE // optional, whether the message should be stored in the session or only in the \TYPO3\CMS\Core\Messaging\FlashMessageQueue object (default is FALSE)
        );
        $this->setOkay = $set;
        return trim($resultValue);
    }

    /**
     * Server-side validation/evaluation on opening the record
     *
     * @param array $parameters Array with key 'value' containing the field value from the database
     * @return string Evaluated field value
     */
    public function deevaluateFieldValue(array $parameters)
    {
        return $parameters['value'];
    }

}