<?php
namespace Porth\Borderstyle\ViewHelpers\Borderstyle;


    /***************************************************************
     *
     *  Copyright notice
     *
     *  (c) 2016 Dr. Dieter Porth <info@mobger.de>
     *
     *  All rights reserved
     *
     *  This script is free software; you can redistribute it and/or modify
     *  it under the terms of the GNU General Public License as published by
     *  the Free Software Foundation; either version 3 of the License, or
     *  (at your option) any later version.
     *
     *  The GNU General Public License can be found at
     *  http://www.gnu.org/copyleft/gpl.html.
     *
     *  This copyright notice MUST APPEAR in all copies of the script!
     ***************************************************************/

/*
 * transfered from  FluidTYPO3/Vhs project under GPLv2 or later.
 *
 */

use \Porth\Borderstyle\ViewHelpers\Render\RequestViewHelper;

/**
 * ### Render: Request
 *
 * Renders a sub-request to the desired Extension, Plugin,
 * Controller and action with the desired arguments.
 *
 * Note: arguments must not be wrapped with the prefix used
 * in GET/POST parameters but must be provided as if the
 * arguments were sent directly to the Controller action.
 */
class ClassnameViewHelper extends RequestViewHelper
{

    /**
     * reduce viewhelper to neede dynamic values
     *
     * @param int $uid
     * @return string
     */
    public function render($uid)
    {
        if ($uid <= 0) {
            return '';
        }

        $arguments = [
            'borderstyleUid' => $uid,
            'graceful' => '1',
            'onError' => ' '
        ];
        $response = parent::render(
            'classname',
            'Theme',
            'Borderstyle',
            'Borderstyle',
            'Porth',
            $arguments
        );
        return $response;
    }


}
