<?php
return [
	'ctrl' => [
		'title'	=> 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_picturing',
		'label' => 'nickname',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

        'languageField' => 'sys_language_uid',
        'translationSource' =>  'l10n_source',
        'transOrigPointerField' => 'l10n_parent',
        'transOrigDiffSourceField' => 'l10n_diffsource',
        'origUid' => 't3_origuid',

        'versioningWS' => TRUE,

		'delete' => 'deleted',
		'enablecolumns' => [
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		],
		'searchFields' => 'nickname,source,sourcewidth,sourceheight,outset,type_repeat,slice,width,fill,',
		'iconfile' => 'EXT:borderstyle/Resources/Public/Icons/tx_borderstyle_domain_model_picturing.svg',
        // hide table in record-list of the modul LIST
        'hideTable' => TRUE
	],
	'interface' => [
		'showRecordFieldList' => 'sys_language_uid, l10n_parent, l10n_diffsource, hidden, nickname, source, width, height, outset, type_repeat, slice, width, fill',
	],
	'types' => [
		'1' => ['showitem' => 'nickname,  source, --pallete;width and height, --palette--;;size, outset, type_repeat, slice, fill, width, --div--;LLL:EXT:cms/locallang_ttc.xlf:tabs.access, starttime, endtime'],
	],
	'palettes' => [
		'1' => ['showitem' => ''],
        'size' => ['showitem' => 'sourcewidth, sourceheight'],
	],
	'columns' => [
	
		'sys_language_uid' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.language',
            'default' => -1,
			'config' => [
				'type' => 'select',
				'renderType' => 'selectSingle',
				'foreign_table' => 'sys_language',
				'foreign_table_where' => 'ORDER BY sys_language.title',
				'items' => [
					['LLL:EXT:lang/locallang_general.xlf:LGL.allLanguages', -1],
					['LLL:EXT:lang/locallang_general.xlf:LGL.default_value', 0]
				],
			],
		],
		'l10n_parent' => [
			'displayCond' => 'FIELD:sys_language_uid:>:0',
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.l18n_parent',
			'config' => [
				'type' => 'select',
				'renderType' => 'selectSingle',
				'items' => [
					['', 0],
				],
				'foreign_table' => 'tx_borderstyle_domain_model_picturing',
				'foreign_table_where' => 'AND tx_borderstyle_domain_model_picturing.pid=###CURRENT_PID### AND tx_borderstyle_domain_model_picturing.sys_language_uid IN (-1,0)',
			],
		],
		'l10n_diffsource' => [
			'config' => [
				'type' => 'passthrough',
			],
		],
        'l10n_source' => [
            'config' => [
                'type' => 'passthrough',
            ],
        ],

		't3ver_label' => [
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.versionLabel',
			'config' => [
				'type' => 'input',
				'size' => 30,
				'max' => 255,
			],
		],
	
		'hidden' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.hidden',
			'config' => [
				'type' => 'check',
			],
		],
		'starttime' => [
			'exclude' => 1,
            'l10n_mode' => 'exclude',
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.starttime',
			'config' => [
				'type' => 'input',
                'renderType' => 'inputDateTime',
                'size' => 13,
				'eval' => 'datetime',
				'checkbox' => 0,
				'default' => 0,
				'range' => [
					'lower' => mktime(0, 0, 0, date('m'), date('d'), date('Y'))
				],
                'behaviour' => [
                    'allowLanguageSynchronization' => true,
                ],
			],
		],
		'endtime' => [
			'exclude' => 1,
            'l10n_mode' => 'exclude',
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.endtime',
			'config' => [
				'type' => 'input',
                'renderType' => 'inputDateTime',
				'size' => 13,
				'eval' => 'datetime',
				'checkbox' => 0,
				'default' => 0,
				'range' => [
					'lower' => mktime(0, 0, 0, date('m'), date('d'), date('Y'))
				],
			],
		],

		'nickname' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_picturing.nickname',
			'config' => [
				'type' => 'input',
				'size' => 30,
				'eval' => 'trim'
			],
		],
		'source' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_picturing.source',
			'config' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::getFileFieldTCAConfig(
				'source',
				[
					'appearance' => [
						'createNewRelationLinkTitle' => 'LLL:EXT:cms/locallang_ttc.xlf:images.addFileReference'
					],
					'foreign_types' => [
						'0' => [
							'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
							--palette--;;filePalette'
						],
						\TYPO3\CMS\Core\Resource\File::FILETYPE_TEXT => [
							'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
							--palette--;;filePalette'
						],
						\TYPO3\CMS\Core\Resource\File::FILETYPE_IMAGE => [
							'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
							--palette--;;filePalette'
						],
						\TYPO3\CMS\Core\Resource\File::FILETYPE_AUDIO => [
							'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
							--palette--;;filePalette'
						],
						\TYPO3\CMS\Core\Resource\File::FILETYPE_VIDEO => [
							'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
							--palette--;;filePalette'
						],
						\TYPO3\CMS\Core\Resource\File::FILETYPE_APPLICATION => [
							'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
							--palette--;;filePalette'
						]
					],
					'maxitems' => 1
				],
				$GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext']
            ),
		],
        'sourcewidth' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_picturing.sourcewidth',
            'config' => [
                'type' => 'input',
                'size' => 4,
                'eval' => 'int'
            ],
        ],
        'sourceheight' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_picturing.sourceheight',
            'config' => [
                'type' => 'input',
                'size' => 4,
                'eval' => 'int'
            ]
        ],
		'outset' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_picturing.outset',
			'config' => [
				'type' => 'input',
				'size' => 30,
				'eval' => 'trim'
			],
		],
		'type_repeat' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_picturing.type_repeat',
			'config' => [
				'type' => 'input',
				'size' => 30,
				'eval' => 'trim',
                'valuePicker' => [
                    'items' => [
                        ['- empty -', ''],
                        [' unset', ' unset'],
                        ['initial' , 'initial'],
                        ['inherit', 'inherit'],
                        ['stretch', ' stretch'],
                        ['repeat' , 'repeat'],
                        ['round', 'round'],
                        ['space', 'space'],
                        ['stretch round', 'stretch round'],
                        ['round space', 'round space'],
                    ],
                ],
			],
		],
		'slice' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_picturing.slice',
			'config' => [
				'type' => 'input',
				'size' => 30,
				'eval' => 'trim'
			],
		],
        'fill' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_picturing.fill',
            'config' => [
                'type' => 'check',
                'default' => 0,
            ],
        ],
        'width' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_picturing.width',
            'config' => [
                'default' => 'not in use',
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim',
                'readOnly' => 1
			],
        ],

	],
];