<?php
return [
	'ctrl' => [
		'title'	=> 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_styling',
		'label' => 'nickname',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,

        'languageField' => 'sys_language_uid',
        'translationSource' =>  'l10n_source',
        'transOrigPointerField' => 'l10n_parent',
        'transOrigDiffSourceField' => 'l10n_diffsource',
        'origUid' => 't3_origuid',

        'versioningWS' => TRUE,

        'delete' => 'deleted',
		'enablecolumns' => [
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		],
		'searchFields' => 'nickname,color,style,',
		'iconfile' => 'EXT:borderstyle/Resources/Public/Icons/tx_borderstyle_domain_model_styling.svg',
        // hide table in record-list of the modul LIST
        'hideTable' => TRUE,
        'rootLevel' => FALSE
	],
	'interface' => [
		'showRecordFieldList' => 'sys_language_uid, l10n_parent, l10n_diffsource, hidden, nickname, color, style',
	],
	'types' => [
//		'1' => ['showitem' => 'sys_language_uid;;;;1-1-1, l10n_parent, l10n_diffsource, hidden;;1, nickname, color, style, --div--;LLL:EXT:cms/locallang_ttc.xlf:tabs.access, starttime, endtime'],
		'1' => ['showitem' => 'nickname, color, style, --div--;LLL:EXT:cms/locallang_ttc.xlf:tabs.access, starttime, endtime'],
	],
	'palettes' => [
		'1' => ['showitem' => ''],
	],
	'columns' => [
	
		'sys_language_uid' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.language',
            'default' => -1,
			'config' => [
				'type' => 'select',
				'renderType' => 'selectSingle',
				'foreign_table' => 'sys_language',
				'foreign_table_where' => 'ORDER BY sys_language.title',
				'items' => [
					['LLL:EXT:lang/locallang_general.xlf:LGL.allLanguages', -1],
					['LLL:EXT:lang/locallang_general.xlf:LGL.default_value', 0]
				],
			],
		],
		'l10n_parent' => [
			'displayCond' => 'FIELD:sys_language_uid:>:0',
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.l18n_parent',
			'config' => [
				'type' => 'select',
				'renderType' => 'selectSingle',
				'items' => [
					['', 0],
				],
				'foreign_table' => 'tx_borderstyle_domain_model_styling',
				'foreign_table_where' => 'AND tx_borderstyle_domain_model_styling.pid=###CURRENT_PID### AND tx_borderstyle_domain_model_styling.sys_language_uid IN (-1,0)',
			],
		],
		'l10n_diffsource' => [
			'config' => [
				'type' => 'passthrough',
			],
		],
        'l10n_source' => [
            'config' => [
                'type' => 'passthrough',
            ],
        ],

		't3ver_label' => [
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.versionLabel',
			'config' => [
				'type' => 'input',
				'size' => 30,
				'max' => 255,
			],
		],
	
		'hidden' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.hidden',
			'config' => [
				'type' => 'check',
			],
		],
		'starttime' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.starttime',
			'config' => [
				'type' => 'input',
                'renderType' => 'inputDateTime',
                'size' => 13,
				'eval' => 'datetime',
				'checkbox' => 0,
				'default' => 0,
				'range' => [
					'lower' => mktime(0, 0, 0, date('m'), date('d'), date('Y'))
				],
                'behaviour' => [
                    'allowLanguageSynchronization' => true,
                ],
			],
		],
		'endtime' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.endtime',
			'config' => [
				'type' => 'input',
                'renderType' => 'inputDateTime',
				'size' => 13,
				'eval' => 'datetime',
				'checkbox' => 0,
				'default' => 0,
				'range' => [
					'lower' => mktime(0, 0, 0, date('m'), date('d'), date('Y'))
				],
                'behaviour' => [
                    'allowLanguageSynchronization' => true,
                ],
			],
		],

		'nickname' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_styling.nickname',
			'config' => [
				'type' => 'input',
				'size' => 30,
				'eval' => 'trim'
			],
		],
		'color' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_styling.color',
            'default' => '',
            'config' => [
                'type' => 'input',
                'size' => 10,
                'eval' => 'trim',
                'renderType' => 'colorpicker',
                ],
		],
		'style' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_styling.style',
            'default' => 'solid',
            'config' => [
                'type' => 'select',
                'renderType' => 'selectSingle',
                'items' => [
                    ['none', 'none'],
                    ['hidden', 'hidden'],
                    ['dotted', 'dotted'],
                    ['dashed', 'dashed'],
                    ['solid', 'solid'],
                    ['double', 'double'],
                    ['groove', 'groove'],
                    ['ridge', 'ridge'],
                    ['inset', 'inset'],
                    ['outset', 'outset'],
                ],
                'size' => 1,
                'maxitems' => 1,
            ],
		],

	],
];