<?php

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
    'Porth.borderstyle',
    'Borderstyle',
    'borderstyle'
);

return [
	'ctrl' => [
		'title'	=> 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme',
		'label' => 'nickname',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'dividers2tabs' => TRUE,
		'sortby' => 'sorting',

        'languageField' => 'sys_language_uid',
        'translationSource' =>  'l10n_source',
        'transOrigPointerField' => 'l10n_parent',
        'transOrigDiffSourceField' => 'l10n_diffsource',
        'origUid' => 't3_origuid',

        'versioningWS' => TRUE,

        'delete' => 'deleted',
		'enablecolumns' => [
			'disabled' => 'hidden',
			'starttime' => 'starttime',
			'endtime' => 'endtime',
		],
		'searchFields' => 'nickname,class_name,radius,width,typus,border_top,border_right,border_bottom,border_left,picturing,',
		'iconfile' => 'EXT:borderstyle/Resources/Public/Icons/tx_borderstyle_domain_model_theme.svg',
        'rootLevel' => false,

	],
	'interface' => [
		'showRecordFieldList' => 'sys_language_uid, l10n_parent, l10n_diffsource, hidden, nickname, class_name, width, radius, typus, border_top, border_right, border_bottom, border_left, picturing',
	],
	'types' => [
		'1' => ['showitem' => 'nickname, class_name, radius, width, typus, border_top, border_right, border_bottom, border_left, picturing, --div--;LLL:EXT:cms/locallang_ttc.xlf:tabs.access, starttime, endtime'],
	],
	'palettes' => [
		'1' => ['showitem' => ''],
	],
	'columns' => [
	
		'sys_language_uid' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.language',
            'default' => -1,
			'config' => [
				'type' => 'select',
				'renderType' => 'selectSingle',
				'foreign_table' => 'sys_language',
				'foreign_table_where' => 'ORDER BY sys_language.title',
				'items' => [
					['LLL:EXT:lang/locallang_general.xlf:LGL.allLanguages', -1],
					['LLL:EXT:lang/locallang_general.xlf:LGL.default_value', 0]
				],
			],
		],
		'l10n_parent' => [
			'displayCond' => 'FIELD:sys_language_uid:>:0',
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.l18n_parent',
			'config' => [
				'type' => 'select',
				'renderType' => 'selectSingle',
				'items' => [
					['', 0],
				],
				'foreign_table' => 'tx_borderstyle_domain_model_theme',
				'foreign_table_where' => 'AND tx_borderstyle_domain_model_theme.pid=###CURRENT_PID### AND tx_borderstyle_domain_model_theme.sys_language_uid IN (-1,0)',
			],
		],
		'l10n_diffsource' => [
			'config' => [
				'type' => 'passthrough',
			],
		],
        'l10n_source' => [
            'config' => [
                'type' => 'passthrough',
            ],
        ],

		't3ver_label' => [
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.versionLabel',
			'config' => [
				'type' => 'input',
				'size' => 30,
				'max' => 255,
			],
		],
	
		'hidden' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.hidden',
			'config' => [
				'type' => 'check',
			],
		],
		'starttime' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.starttime',
			'config' => [
				'type' => 'input',
                'renderType' => 'inputDateTime',
				'size' => 13,
				'eval' => 'datetime',
				'checkbox' => 0,
				'default' => 0,
				'range' => [
					'lower' => mktime(0, 0, 0, date('m'), date('d'), date('Y'))
				],
                'behaviour' => [
                    'allowLanguageSynchronization' => true,
                ],

			],
		],
		'endtime' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.endtime',
			'config' => [
				'type' => 'input',
                'renderType' => 'inputDateTime',
				'size' => 13,
				'eval' => 'datetime',
				'checkbox' => 0,
				'default' => 0,
				'range' => [
					'lower' => mktime(0, 0, 0, date('m'), date('d'), date('Y'))
				],
                'behaviour' => [
                    'allowLanguageSynchronization' => true,
                ],
			],
		],

		'nickname' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.nickname',
			'config' => [
				'type' => 'input',
				'size' => 30,
				'eval' => 'trim,required'
			],
		],
		'class_name' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.class_name',
			'config' => [
				'type' => 'input',
				'size' => 30,
				'eval' => 'trim,required,lower,alpha'
			],
		],
		'radius' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.radius',
            'displayCond' => 'FIELD:picturing:REQ:false',
			'config' => [
                'type' => 'input',
                'size' => 30,
                'is_in' => '4;%;ch,em,ex,rem,vh,vw,vmin,vmax,px,cm,mm,in,pc,pt;;',
				'eval' => 'trim,Porth\Borderstyle\Evaluation\TupelEvaluation', // @todo eval is not really finished yet - Porth 2016
			],
		],
        'width' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.width',
            'default' => '0px',
            'displayCond' =>  'FIELD:picturing:REQ:false',
            'config' => [
                'type' => 'input',
                'size' => 20,
                'is_in' => 'ch,em,ex,rem,vh,vw,vmin,vmax,px,cm,mm,in,pc,pt,%;thin,medium,thick',
                'eval' => 'trim',
                'valuePicker' => [
                    'items' => [
                        ['- empty -', ''],
                        [' inherit', ' inherit'],
                        ['thick thin 3% 4em' , '1px 2rem 3% 4em'],
                        ['1px 2rem 3%', '1px 2rem 3%'],
                        ['1px 2rem', '1px 2rem'],
                        ['1%', '1%'],
                        ['thin (1px; 2px <IE8)', 'thin'],
                        ['medium (3px; 4px <IE8)', 'medium'],
                        ['thick (5px; 6px <IE8)', 'thick'],
                    ],
                ],
            ],
        ],
        'typus' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.typus',
            'default' => '1',
            'onChange' => 'reload',
            'displayCond' => 'FIELD:picturing:REQ:false',
            'config' => [
                'type' => 'select',
                'renderType' => 'selectSingle',
                'onChange' => 'reload',
                'items' => [
                    ['LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.typus.1', '1'],
                    ['LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.typus.2', '2'],
                    ['LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.typus.3', '3'],
                    ['LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.typus.4', '4'],
                    ['LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.typus.0', '0'],
                ],
                'size' => 1,
                'maxitems' => 5,
            ],
        ],
		'border_top' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.border_top',
            'displayCond' => 'FIELD:picturing:REQ:false',
			'config' => [
				'type' => 'inline',
				'foreign_table' => 'tx_borderstyle_domain_model_styling',
				'minitems' => 0,
				'maxitems' => 5,
				'appearance' => [
					'collapseAll' => 0,
					'levelLinksPosition' => 'top',
					'showSynchronizationLink' => 1,
					'showPossibleLocalizationRecords' => 1,
					'showAllLocalizationLink' => 1
				],
			],
		],
		'border_right' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.border_right',
            'displayCond' => [
                'AND' => [
                    'FIELD:typus:>:1',
                    'FIELD:picturing:REQ:false'
                ]
            ],
			'config' => [
				'type' => 'inline',
				'foreign_table' => 'tx_borderstyle_domain_model_styling',
				'minitems' => 0,
				'maxitems' => 5,
				'appearance' => [
					'collapseAll' => 0,
					'levelLinksPosition' => 'top',
					'showSynchronizationLink' => 1,
					'showPossibleLocalizationRecords' => 1,
					'showAllLocalizationLink' => 1
				],
			],
		],
		'border_bottom' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.border_bottom',
            'displayCond' => [
                'AND' => [
                    'FIELD:typus:>:2',
                    'FIELD:picturing:REQ:false'
                ]
            ],
			'config' => [
				'type' => 'inline',
				'foreign_table' => 'tx_borderstyle_domain_model_styling',
				'minitems' => 0,
				'maxitems' => 5,
				'appearance' => [
					'collapseAll' => 0,
					'levelLinksPosition' => 'top',
					'showSynchronizationLink' => 1,
					'showPossibleLocalizationRecords' => 1,
					'showAllLocalizationLink' => 1
				],
			],
		],
		'border_left' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.border_left',
            'displayCond' => [
                'AND' => [
                    'FIELD:typus:>:3',
                    'FIELD:picturing:REQ:false'
                ]
            ],
			'config' => [
				'type' => 'inline',
				'foreign_table' => 'tx_borderstyle_domain_model_styling',
				'minitems' => 0,
				'maxitems' => 5,
				'appearance' => [
					'collapseAll' => 0,
					'levelLinksPosition' => 'top',
					'showSynchronizationLink' => 1,
					'showPossibleLocalizationRecords' => 1,
					'showAllLocalizationLink' => 1
				],
			],
		],
		'picturing' => [
			'exclude' => 1,
			'label' => 'LLL:EXT:borderstyle/Resources/Private/Language/locallang_db.xlf:tx_borderstyle_domain_model_theme.picturing',
            'displayCond' => 'FIELD:typus:>:0',
            'onChange' => 'reload',
            'config' => [
				'type' => 'inline',
                'onChange' => 'reload',
                'foreign_table' => 'tx_borderstyle_domain_model_picturing',
				'minitems' => 0,
				'maxitems' => 5,
				'appearance' => [
					'collapseAll' => 0,
					'levelLinksPosition' => 'top',
					'showSynchronizationLink' => 1,
					'showPossibleLocalizationRecords' => 1,
					'showAllLocalizationLink' => 1
				],
			],
		],
		
	],
];