<?php

namespace Porth\Borderstyle\Tests\Unit\Domain\Model;


    /***************************************************************
     *
     *  Copyright notice
     *
     *  (c) 2016 Dr. Dieter Porth <info@mobger.de>
     *
     *  All rights reserved
     *
     *  This script is free software; you can redistribute it and/or modify
     *  it under the terms of the GNU General Public License as published by
     *  the Free Software Foundation; either version 3 of the License, or
     *  (at your option) any later version.
     *
     *  The GNU General Public License can be found at
     *  http://www.gnu.org/copyleft/gpl.html.
     *
     *  This copyright notice MUST APPEAR in all copies of the script!
     ***************************************************************/

/**
 * Test case for class \Porth\Borderstyle\Domain\Model\Theme.
 *
 * @copyright Copyright belongs to the respective authors
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 * @author Dr. Dieter Porth <info@mobger.de>
 */
class ThemeTest extends \TYPO3\CMS\Core\Tests\UnitTestCase
{
	/**
	 * @var \Porth\Borderstyle\Domain\Model\Theme
	 */
	protected $subject = NULL;

	public function setUp()
	{
		$this->subject = new \Porth\Borderstyle\Domain\Model\Theme();
	}

	public function tearDown()
	{
		unset($this->subject);
	}

	/**
	 * @test
	 */
	public function getNicknameReturnsInitialValueForString()
	{
		$this->assertSame(
			'',
			$this->subject->getNickname()
		);
	}

	/**
	 * @test
	 */
	public function setNicknameForStringSetsNickname()
	{
		$this->subject->setNickname('Conceived at T3CON10');

		$this->assertAttributeEquals(
			'Conceived at T3CON10',
			'nickname',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getClassNameReturnsInitialValueForString()
	{
		$this->assertSame(
			'',
			$this->subject->getClassName()
		);
	}

	/**
	 * @test
	 */
	public function setClassNameForStringSetsClassName()
	{
		$this->subject->setClassName('Conceived at T3CON10');

		$this->assertAttributeEquals(
			'Conceived at T3CON10',
			'className',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getRadiusReturnsInitialValueForString()
	{
		$this->assertSame(
			'',
			$this->subject->getRadius()
		);
	}

	/**
	 * @test
	 */
	public function setRadiusForStringSetsRadius()
	{
		$this->subject->setRadius('Conceived at T3CON10');

		$this->assertAttributeEquals(
			'Conceived at T3CON10',
			'radius',
			$this->subject
		);
	}

    /**
     * @test
     */
    public function getWidthReturnsInitialValueForString()
    {
        $this->assertSame(
            '',
            $this->subject->getWidth()
        );
    }

    /**
     * @test
     */
    public function setWidthForStringSetsWidth()
    {
        $this->subject->setWidth('Conceived at T3CON10');

        $this->assertAttributeEquals(
            'Conceived at T3CON10',
            'width',
            $this->subject
        );
    }

    /**
     * @test
     */
    public function getTypusReturnsInitialValueForInt()
    {
        $this->assertSame(
            '',
            $this->subject->getTypus()
        );
    }

    /**
     * @test
     */
    public function setTypusForStringSetsTypus()
    {
        $this->subject->setTypus('Conceived at T3CON10');

        $this->assertAttributeEquals(
            'Conceived at T3CON10',
            'width',
            $this->subject
        );
    }

	/**
	 * @test
	 */
	public function getBorderTopReturnsInitialValueForStyling()
	{
		$this->assertEquals(
			NULL,
			$this->subject->getBorderTop()
		);
	}

	/**
	 * @test
	 */
	public function setBorderTopForStylingSetsBorderTop()
	{
		$borderTopFixture = new \Porth\Borderstyle\Domain\Model\Styling();
		$this->subject->setBorderTop($borderTopFixture);

		$this->assertAttributeEquals(
			$borderTopFixture,
			'borderTop',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getBorderRightReturnsInitialValueForStyling()
	{
		$this->assertEquals(
			NULL,
			$this->subject->getBorderRight()
		);
	}

	/**
	 * @test
	 */
	public function setBorderRightForStylingSetsBorderRight()
	{
		$borderRightFixture = new \Porth\Borderstyle\Domain\Model\Styling();
		$this->subject->setBorderRight($borderRightFixture);

		$this->assertAttributeEquals(
			$borderRightFixture,
			'borderRight',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getBorderBottomReturnsInitialValueForStyling()
	{
		$this->assertEquals(
			NULL,
			$this->subject->getBorderBottom()
		);
	}

	/**
	 * @test
	 */
	public function setBorderBottomForStylingSetsBorderBottom()
	{
		$borderBottomFixture = new \Porth\Borderstyle\Domain\Model\Styling();
		$this->subject->setBorderBottom($borderBottomFixture);

		$this->assertAttributeEquals(
			$borderBottomFixture,
			'borderBottom',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getBorderLeftReturnsInitialValueForStyling()
	{
		$this->assertEquals(
			NULL,
			$this->subject->getBorderLeft()
		);
	}

	/**
	 * @test
	 */
	public function setBorderLeftForStylingSetsBorderLeft()
	{
		$borderLeftFixture = new \Porth\Borderstyle\Domain\Model\Styling();
		$this->subject->setBorderLeft($borderLeftFixture);

		$this->assertAttributeEquals(
			$borderLeftFixture,
			'borderLeft',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getPicturingReturnsInitialValueForPicturing()
	{
		$this->assertEquals(
			NULL,
			$this->subject->getPicturing()
		);
	}

	/**
	 * @test
	 */
	public function setPicturingForPicturingSetsPicturing()
	{
		$picturingFixture = new \Porth\Borderstyle\Domain\Model\Picturing();
		$this->subject->setPicturing($picturingFixture);

		$this->assertAttributeEquals(
			$picturingFixture,
			'picturing',
			$this->subject
		);
	}
}
